# wxZlibOutputStream Class Reference
[Archive support, Streams]

`#include <wx/zstream.h>`

Inheritance diagram for wxZlibOutputStream:
[legend]

## Detailed Description

This stream compresses all data written to it.

The compressed output can be in zlib or gzip format. Note that writing the gzip format requires zlib version 1.2.1 or greater (the builtin version does support gzip format).

The stream is not seekable, wxOutputStream::SeekO() returns wxInvalidOffset.

##

Library: wxBase

Category: Archive support, Streams

See also:
  wxOutputStream, wxZlibInputStream

## Public Member Functions
| wxZlibOutputStream (wxOutputStream &stream, int level=-1, int flags=wxZLIB_ZLIB)
| Creates a new write-only compressed stream.
| wxZlibOutputStream (wxOutputStream *stream, int level=-1, int flags=wxZLIB_ZLIB)
| Creates a new write-only compressed stream.
bool | SetDictionary (const char *data, const size_t datalen)
| Sets the dictionary to the specified chunk of data.
bool | SetDictionary (const wxMemoryBuffer &buf)
| Sets the dictionary to the specified chunk of data.
## Static Public Member Functions
static bool | CanHandleGZip ()
| Returns true if zlib library in use can handle gzip compressed data.

List of all members.

## Constructor & Destructor Documentation

wxZlibOutputStream::wxZlibOutputStream | ( | wxOutputStream & | stream,
|  | int | level = `-1`,
|  | int | flags = `wxZLIB_ZLIB` |
| ) |  |  |

Creates a new write-only compressed stream.

level means level of compression. It is number between 0 and 9 (including these values) where 0 means no compression and 9 best but slowest compression. -1 is default value (currently equivalent to 6).

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

The flags wxZLIB_ZLIB and wxZLIB_GZIP specify whether the output data will be in zlib or gzip format. wxZLIB_ZLIB is the default.

If flags is wxZLIB_NO_HEADER, then a raw deflate stream is output without either zlib or gzip headers. This is a lower level mode, which is not usually used directly. It can be used to embed a raw deflate stream in a higher level protocol.

The values of the wxZlibCompressionLevels and wxZLibFlags enumerations can be used.

wxZlibOutputStream::wxZlibOutputStream | ( | wxOutputStream * | stream,
|  | int | level = `-1`,
|  | int | flags = `wxZLIB_ZLIB` |
| ) |  |  |

Creates a new write-only compressed stream.

level means level of compression. It is number between 0 and 9 (including these values) where 0 means no compression and 9 best but slowest compression. -1 is default value (currently equivalent to 6).

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

The flags wxZLIB_ZLIB and wxZLIB_GZIP specify whether the output data will be in zlib or gzip format. wxZLIB_ZLIB is the default.

If flags is wxZLIB_NO_HEADER, then a raw deflate stream is output without either zlib or gzip headers. This is a lower level mode, which is not usually used directly. It can be used to embed a raw deflate stream in a higher level protocol.

The values of the wxZlibCompressionLevels and wxZLibFlags enumerations can be used.

## Member Function Documentation

static bool wxZlibOutputStream::CanHandleGZip | ( |  | ) | `[static]`

Returns true if zlib library in use can handle gzip compressed data.

bool wxZlibOutputStream::SetDictionary | ( | const wxMemoryBuffer & | buf | ) |

Sets the dictionary to the specified chunk of data.

This can improve compression rate but note that the dictionary has to be the same when you deflate the data as when you inflate the data, otherwise you will inflate corrupted data.

Returns true if the dictionary was successfully set.

bool wxZlibOutputStream::SetDictionary | ( | const char * | data,
|  | const size_t | datalen |
| ) |  |  |

Sets the dictionary to the specified chunk of data.

This can improve compression rate but note that the dictionary has to be the same when you deflate the data as when you inflate the data, otherwise you will inflate corrupted data.

Returns true if the dictionary was successfully set.

|  | [ top ]